{
TApplicationCheck v1.3
(32 bit version)
By: Pekka E. Haapalainen
7th May 1997
e-mail:  alpo@iki.fi

Version 1.3	- .
(7th May 1997)

Version 1.2	- This is the first release of the TApplicationCheck. The version number was actually 1.0 but
                  I changed it to 1.2 when finishing 1.3 (The DOS/BP version was 1.0).
(7th April 1997)
}
unit AppCheck;

{$A+}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, DsgnIntf;

type
  TAppID = record
    id         : string [30];
    version    : word;
    crc        : word;
    calculated : boolean;
  end;
  TApplicationCheck = class(TComponent)
  private
    FAbout  : string;
    FActive : boolean;
    procedure SetActive (newstate : boolean);
    function SearchTheIDAndCalcCRC (fname : string;
                                    Var idb : TAppID;
                                    Var idpos : integer;
                                    Var fsize : integer;
                                    Var totcrc : word) : integer;
    function CheckTheCRC : integer;
    procedure DoIt;
  public
    constructor Create(AOwner:TComponent); override;
    procedure Loaded; override;
    destructor Destroy; override;
    procedure ShowAbout;
  published
    property About: string read FAbout write FAbout stored False;
    property Active: boolean read FActive write SetActive default False;
  end;

procedure Register;

implementation

uses
  StBase, StStrS;    // units from Turbo Power SysTools library

Const
  AppID : TAppID = (id: 'ApplicationCheckIDBlock'; version: 0100;
                    crc: $FFFF; calculated : false);
  MAXBUFSIZE = $8000;
  acerrGOODCRC             = 1;
  acerrNOERROR             = 0;
  acerrAPLLIDBLOCKNOTFOUND = -1;
  acerrBADCRCINAPLLIDBLOCK = -2;
  acerrCRCNOTCALCULATED    = -3;
  acerrCANNOTWRITECRC      = -4;
  acerrCANNOTREADFILE      = -5;
  ccitt_16 : array [0..255] of word = (
    $0000, $1021, $2042, $3063, $4084, $50A5, $60C6, $70E7,
    $8108, $9129, $A14A, $B16B, $C18C, $D1AD, $E1CE, $F1EF,
    $1231, $0210, $3273, $2252, $52B5, $4294, $72F7, $62D6,
    $9339, $8318, $B37B, $A35A, $D3BD, $C39C, $F3FF, $E3DE,
    $2462, $3443, $0420, $1401, $64E6, $74C7, $44A4, $5485,
    $A56A, $B54B, $8528, $9509, $E5EE, $F5CF, $C5AC, $D58D,
    $3653, $2672, $1611, $0630, $76D7, $66F6, $5695, $46B4,
    $B75B, $A77A, $9719, $8738, $F7DF, $E7FE, $D79D, $C7BC,
    $48C4, $58E5, $6886, $78A7, $0840, $1861, $2802, $3823,
    $C9CC, $D9ED, $E98E, $F9AF, $8948, $9969, $A90A, $B92B,
    $5AF5, $4AD4, $7AB7, $6A96, $1A71, $0A50, $3A33, $2A12,
    $DBFD, $CBDC, $FBBF, $EB9E, $9B79, $8B58, $BB3B, $AB1A,
    $6CA6, $7C87, $4CE4, $5CC5, $2C22, $3C03, $0C60, $1C41,
    $EDAE, $FD8F, $CDEC, $DDCD, $AD2A, $BD0B, $8D68, $9D49,
    $7E97, $6EB6, $5ED5, $4EF4, $3E13, $2E32, $1E51, $0E70,
    $FF9F, $EFBE, $DFDD, $CFFC, $BF1B, $AF3A, $9F59, $8F78,
    $9188, $81A9, $B1CA, $A1EB, $D10C, $C12D, $F14E, $E16F,
    $1080, $00A1, $30C2, $20E3, $5004, $4025, $7046, $6067,
    $83B9, $9398, $A3FB, $B3DA, $C33D, $D31C, $E37F, $F35E,
    $02B1, $1290, $22F3, $32D2, $4235, $5214, $6277, $7256,
    $B5EA, $A5CB, $95A8, $8589, $F56E, $E54F, $D52C, $C50D,
    $34E2, $24C3, $14A0, $0481, $7466, $6447, $5424, $4405,
    $A7DB, $B7FA, $8799, $97B8, $E75F, $F77E, $C71D, $D73C,
    $26D3, $36F2, $0691, $16B0, $6657, $7676, $4615, $5634,
    $D94C, $C96D, $F90E, $E92F, $99C8, $89E9, $B98A, $A9AB,
    $5844, $4865, $7806, $6827, $18C0, $08E1, $3882, $28A3,
    $CB7D, $DB5C, $EB3F, $FB1E, $8BF9, $9BD8, $ABBB, $BB9A,
    $4A75, $5A54, $6A37, $7A16, $0AF1, $1AD0, $2AB3, $3A92,
    $FD2E, $ED0F, $DD6C, $CD4D, $BDAA, $AD8B, $9DE8, $8DC9,
    $7C26, $6C07, $5C64, $4C45, $3CA2, $2C83, $1CE0, $0CC1,
    $EF1F, $FF3E, $CF5D, $DF7C, $AF9B, $BFBA, $8FD9, $9FF8,
    $6E17, $7E36, $4E55, $5E74, $2E93, $3EB2, $0ED1, $1EF0
);

var
  BUFSIZE : integer;

type
  TAboutProperty = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue:string; override;
  end;

procedure Register;
begin
  RegisterComponents ('System', [TApplicationCheck]);
  // register the 'About' property editor
  RegisterPropertyEditor (TypeInfo (String), TApplicationCheck,
                          'About', TAboutProperty);
end;

constructor TApplicationCheck.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
(********
  if FActive and not (csDesigning in ComponentState) then
    DoIt;
*********)
end;

procedure TApplicationCheck.Loaded;
begin
  inherited Loaded;	{ always call the inherited Loaded first! }
  if FActive and not (csDesigning in ComponentState) then
    DoIt;
end;

destructor TApplicationCheck.Destroy;
begin
  inherited Destroy;
end;

procedure TApplicationCheck.SetActive (newstate : boolean);
begin
  FActive := newstate;
end;

procedure TAboutProperty.Edit;
begin
  TApplicationCheck(GetComponent(0)).ShowAbout;
end;

function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
  GetAttributes := [paDialog, paReadOnly];
end;

function TAboutProperty.GetValue: String;
begin
  GetValue := '(About)';
end;

procedure TApplicationCheck.ShowAbout;
var
  msg : string;
const
  cr = chr (13);
begin
  msg := 'TApplicationCheck  v.1.3' + cr + 'A Freeware component' + cr;
  msg := msg + '(32 bit version only)' + cr + cr;
  msg := msg + 'Copyright  1997 Pekka E. Haapalainen' + cr;
  msg := msg + 'Turku, Finland' + cr;
  msg := msg + 'e-mail: alpo@iki.fi' + cr;
  ShowMessage(msg);
end;

// 16-bit CRC function
function CalcCrc (count  : word;
                crc    : word;
                buffer : array of byte): word;
var
  idx : integer;
begin
  idx := 0;
  while idx < count do
  begin
    crc := word ((crc shl 8) xor ccitt_16 [(crc shr 8) xor buffer [idx]]);
    inc (idx);
  end;
  CalcCrc := crc;
end;

function TApplicationCheck.SearchTheIDAndCalcCRC (fname : string;
                                                  Var idb : TAppID;
                                                  Var idpos : integer;
                                                  Var fsize : integer;
                                                  Var totcrc : word) : integer;
var
  fil      : file;
  buff     : array [1..MAXBUFSIZE] of byte;
  BMSTable : BTable;
  CRC      : word;
  CRCBuff  : array [1..2] of byte absolute CRC;
  BytesRead : integer;
  AppIDFound,
  SearchResult : boolean;
  SearchString : ShortString;
  fpos : cardinal;
begin
  SearchTheIDAndCalcCRC := acerrNOERROR;
  idpos := 0;
  fsize := 0;
  SearchString := AppID.id;
  AppIDFound := false;
  totcrc := 0;
  BMMakeTableS (SearchString, BMSTable);
  try
    try
      AssignFile (fil, fname);
      FileMode := 0; // read only
      Reset (fil, 1);
      // read the file until AppIDBlock found
      while not eof (fil) do
      begin
        BlockRead (fil, buff, BUFSIZE, BytesRead);
        // we don't actually need the file size, but it takes not much time to calculate
        inc (fsize, BytesRead);
        // while not AppID found do search it
        if not AppIDFound then
        begin
          SearchResult := BMSearchS (buff, BytesRead, BMSTable, SearchString, fpos);
          if SearchResult and not AppIDFound and
             (fpos < (BUFSIZE - SizeOf(TAppID))) then
          begin
            inc (idpos, fpos - 1);
            Move (buff [fpos - 1], idb, SizeOf (TAppID));
            // clear the AppID for CRC calculation
            FillChar (buff [fpos - 1], SizeOf (TAppID), 0);
            AppIDFound := true;
          end
          else
            inc (idpos, BytesRead);
        end;
        // calculate the CRC of 32 kB buffer (or smaller, see value of BytesRead)
        CRC := CalcCrc (BytesRead, 0, buff);
        // calculate the CRC of CRC's
        totcrc := CalcCrc (2, totcrc, CRCBuff);
      end;
    except
      SearchTheIDAndCalcCRC := acerrCANNOTREADFILE;
      exit;
    end;
  finally
     CloseFile (fil);
     FileMode := 2; // read/write, the default
  end;
  if not AppIDFound then
    SearchTheIDAndCalcCRC := acerrAPLLIDBLOCKNOTFOUND;
end;

function TApplicationCheck.CheckTheCRC : integer;
var
  AID           : TAppID;
  TotalCRC      : word;
  FileName      : string;
  AppIDPosition : integer;
  res           : integer;
  AppSize       : integer;
begin
  CheckTheCRC := acerrNOERROR;
  FileName := ParamStr (0);
  res := SearchTheIDAndCalcCRC (FileName, AID, AppIDPosition, AppSize, TotalCRC);
  if res = acerrNOERROR then
  begin
    if AID.crc <> TotalCRC then
    begin
      if not AID.calculated then
        CheckTheCRC := acerrCRCNOTCALCULATED
      else
        CheckTheCRC := acerrBADCRCINAPLLIDBLOCK;
    end
    else
      CheckTheCRC := acerrGOODCRC;
  end
  else
    CheckTheCRC := res;
end;

procedure TApplicationCheck.DoIt;
var
  res : integer;
begin
  BUFSIZE := MAXBUFSIZE;
  res := CheckTheCRC;
  if res = acerrAPLLIDBLOCKNOTFOUND then
  begin
    BUFSIZE := MAXBUFSIZE - SizeOf (TAppID);
    if CheckTheCRC = acerrAPLLIDBLOCKNOTFOUND then
    begin
      ShowMessage ('Application ID block not found!');
    end;
  end;
  if res = acerrBADCRCINAPLLIDBLOCK then
  begin
    ShowMessage ('Application has a CRC error!' + #13 + 'Application will be terminated...');
  end;
  if res = acerrCRCNOTCALCULATED then
  begin
    ShowMessage ('The Application CRC is not calculated yet.');
    Application.Terminate;
  end;
  if res <> acerrGOODCRC then
    Application.Terminate;
end;

initialization

finalization

end.




